/***************************************************************************
                          savegames.h  -  description
                             -------------------
    begin                : Wed Jun 17 2004
    copyright            : (C) 2004, 2005 by Thomas Friedrichsmeier
    email                : tfry@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef SAVEGAMES_H
#define SAVEGAMES_H

#include <qstring.h>
#include <qstringlist.h>
#include <qptrlist.h>

#include "tpbase.h"

/**
Manage saved games

@author Thomas Friedrichsmeier
*/
class SaveGames : public TPBase {
public:
	SaveGames();

	~SaveGames();
    
	struct GameDescription {
		QString mission_file;
		QString mission_title;
		QString mission_version;
		int level;
		int lives;
		float fuel;
		float score;
	};
	
	/** save the given game-state */
	void addSaveGame (const QString &mission_file, const QString &mission_title, const QString &mission_version, int level, int lives, float fuel, float score);
    
	/** returns the saved games in a list */
	QPtrList<GameDescription> *getList () { return &saves_list; };

	/** saves the current list of saved games */
	void saveList ();
private:
	/** reads the stored list of saved games */
	void readList ();

	/** the actual list */
	QPtrList<GameDescription> saves_list;
};

#endif
